import { EventEmitter } from 'eventemitter3';
interface ReconnectOptions {
    minDelay: number;
    maxDelay: number;
    growFactor: number;
    maxRetries: number;
}
export default class WebSocketClient extends EventEmitter {
    url: string;
    EVENTS: {
        OPEN: string;
        ERROR: string;
        PONG: string;
        MESSAGE: string;
        CLOSE: string;
    };
    private sock;
    private keepClosed;
    private pingInterval;
    private idleTimer;
    private pingTimer;
    private reconnectOptions;
    private reconnectTimer;
    private reconnectTrials;
    private reconnectDelay;
    private websocketClass;
    constructor(url: string);
    setReconnectOptions(options: Partial<ReconnectOptions>): void;
    _maybeReconnect(): void;
    setPingInterval(interval: number): void;
    setWebsocketClass(websocketClass: any): void;
    _maybeResetIdleTimer(): void;
    _startPingTimer(): void;
    open(url?: string): void;
    send(msg: string): void;
    sendPing(): void;
    sendMessage(kind: string, payload: any): void;
    close(keepClosed?: boolean): void;
}
export {};
